# async-modules-loader

 
async-modules-loader is a node.js package for loading npm modules asynchronously with a single function, All you have to give is a single array.

**[Follow me (@sayanmohsin) on Twitter!](https://twitter.com/SayanMohsin)**
**[Follow me (@sayanmohsin) on github!](https://github.com/sayanmohsin)**

* [Installation](#installation)
* [Usage](#usage)
  * [Simple Usage](#simple usage to run the loadmodules function)
* [Configuration Options](#configuration-options)
* [License](#license)
* [Author](#author)

## Installation

This is a [Node.js](https://nodejs.org/en/) module available through the
[npm registry](https://www.npmjs.com/). Installation is done using the
[`npm install` command](https://docs.npmjs.com/getting-started/installing-npm-packages-locally):

```sh
$ npm install async-modules-loader
```

## Usage

### Simple Usage (simple usage to run the loadmodules function)

```javascript
var aml = require('async-modules-loader');
var aml_options = [{
    name: 'passport',
    options: {
        url: 'passport',
        default: true,
        moduleName: 'passport'
    }
}, {
    name: 'cors',
    options: {
        url: 'cors',
        default: false,
        moduleName: 'cors'
    }
}]

aml.loadModules(aml_options).then(importedModules => {
	console.log(importedModules)
}).catch(err => {
	console.log(err)
})

// or with async/await
var importedModules = await aml.loadModules(aml_options);

```

## Configuration Options

* `name`: name of the package
* `options`: Configures the npm packages:
  - `url` - name of the npm package
  - `default` - set to `true` for automatically importing the default value
  - `moduleName` - set a dynamic name for the variable to import to. Should follow the basic rules of naming a variable.
  
## License

[MIT License](http://www.opensource.org/licenses/mit-license.php)

## Author

[Sayan Mohsin](https://github.com/TroyGoode) ([iamsayanmohsin@gmail.com](mailto:iamsayanmohsin@gmail.com))

[npm-url]: https://www.npmjs.com/package/async-modules-loader