// let modules = [{
//     name: 'passport',
//     options: {
//         url: 'passport',
//         default: true,
//         moduleName: 'passport'
//     }
// }, {
//     name: 'cors',
//     options: {
//         url: 'cors',
//         default: false,
//         moduleName: 'cors'
//     }
// }]

function* modulesIterator(modules) {
    yield* modules;
}

export const loadModules = async (modules) => {
    let module = {};
    let moduleName = '';
    let importedModulesObjects = {};
    try {
        let it = modulesIterator(modules);
        let totalModules = modules.length;
        while (totalModules > 0) {
            module = it.next().value;
            moduleName = module.options.moduleName;
            importedModulesObjects[moduleName] = {}
            importedModulesObjects[moduleName].promise = import(module.options.url);
            importedModulesObjects[moduleName].options = module.options
            console.log('after promise gen')
            totalModules--;
        }
        console.log('after promise gen while')
        for (const importedModulesObject in importedModulesObjects) {
            let importDefault = importedModulesObjects[importedModulesObject].options.default;
            let importedModule = await importedModulesObjects[importedModulesObject].promise;
            if (importDefault) {
                importedModulesObjects[importedModulesObject].resolved = importedModule.default;
            } else {
                importedModulesObjects[importedModulesObject].resolved = importedModule;
            }
            importedModulesObjects[importedModulesObject] = importedModulesObjects[importedModulesObject].resolved;
            delete importedModulesObjects[importedModulesObject].resolved;
            delete importedModulesObjects[importedModulesObject].promise;
            delete importedModulesObjects[importedModulesObject].options;

        }
        return importedModulesObjects;
    } catch (err) {
        throw err;
    }
}



// {
//     url: 'passport',
//     options: {
//         default: true,
//         moduleName: 'passport'
//     }
// }

// loadModule(modules).then(rsp => {
//     console.log('rsp: ', rsp);
// })

// export const loadmodule = async () => {

//     modules.map(module => {



//     })
//     // return [{
//     //         default: passport
//     //     },
//     //     {
//     //         default: passportInit
//     //     }
//     // ] = await Promise.all([
//     //     await import('passport'),
//     //     import('./configs/passport.config')
//     // ])
// }